<% @Language=VBScript %>
<!-- #include file="routines.vbs" -->
<%
    Function CheckExt(s)
        If s = "" Then 
            CheckExt = False
        ElseIf Instr(s,".") > 0 Or InStr(s,":") > 0 Or InStr(s,";") > 0 Then
            CheckExt = False
        Else
            CheckExt = True
        End If
    End Function
    
    Set cfg = Server.CreateObject("newObjects.utilctls.ConfigFile")
    Dim app, defaults, aliaspresets
    Set aliaspresets = cfg.Read(Server.MapPath("comaliaspresets.cfg"))
    
    If fileApp = "" Then
        ' Read default
        Set app = cfg.Read(Server.MapPath("defaults/alp.application"))
        fileApp = pathFor & "alp.application"
        dirApp = pathFor
        cfg.Write fileApp,app
    Else
        Set app = cfg.Read(fileApp)
    End If 
    
    Set defaults = cfg.Read(Server.MapPath("defaults.app"))
    
    ' Check consistency
    Set comMap = OpenCreateSection(cfg,app,"APPLICATION/ExecutionMap/" & Request("EXT") & "/COMMAP")
    aliasName = ""
    aliasCLSID = ""
    



    Dim n, message, str, bShowMessageOnly, Module, ext
    message = ""
    bShowMessageOnly = False
    
    If Request("Edit").Count > 0 Then
        aliasName = CStr(Request("COMMAP"))
        aliasCLSID = comMap(aliasName)
    ElseIf Request("Remove").Count > 0 Then
        comMap.Remove Request("COMMAP")
        cfg.Write fileApp, app
    ElseIf Request("RemoveAll").Count > 0 Then
        comMap.Clear
        cfg.Write fileApp, app
    ElseIf Request("AddPreset").Count > 0 Then
        For I = 1 To aliaspresets(Request("AliasPreset"))("ALIASES").Count
            comMap.Add aliaspresets(Request("AliasPreset"))("ALIASES").Key(I),aliaspresets(Request("AliasPreset"))("ALIASES")(I)
        Next
        cfg.Write fileApp, app
    ElseIf Request("Update").Count > 0 Then
        str = CStr(Request("aliasName"))
        comMap(str) = CStr(Request("aliasCLSID"))
        cfg.Write fileApp, app
    Else
        bShowMessageOnly = False
    End IF
    
%>
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
<SCRIPT>
    function pasteCLSID() {
        document.all('aliasCLSID').focus();
        external.Paste();
    }
    function pasteProgID() {
        document.all('aliasName').focus();
        external.Paste();
    }
</SCRIPT>
</head>

<body topmargin="0" leftmargin="0">

<table border="0" width="100%" cellspacing="0">
  <!-- #include file="head.inc" -->
  <tr>
    <td width="100%">
        <H4>COM Map</H4>
        <BLOCKQUOTE>
            <%= pathFor %><BR>
            <A HREF="app.asp?Path=<%= pathFor %>">Back to application settings</A>
        </BLOCKQUOTE>
        <% If bShowMessageOnly Then %>
            <I><B><%= message %></B></I>
        <% Else %>
            <DIV ALIGN="CENTER">
            <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
                <INPUT TYPE="HIDDEN" NAME="Path" VALUE="<%= pathFor %>">
                <INPUT TYPE="HIDDEN" NAME="EXT" VALUE="<%= Request("EXT") %>">
                COM Aliases:
                <A HREF="javascript: void window.open('help/default.asp?Page=commap.htm&Mark=Edit')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                <BR>
                <SELECT NAME="COMMAP" SIZE="10" CLASS="inpsel" STYLE="width: 450px; overflow-x: scroll">
                    <% For I = 1 To comMap.Count %>
                        <% If aliasName = comMap.Key(I) Then %>
                            <OPTION SELECTED VALUE="<%= comMap.Key(I) %>"><%= comMap.Key(I) %> = <%= comMap(I) %></OPTION>
                        <% Else %>
                            <OPTION VALUE="<%= comMap.Key(I) %>"><%= comMap.Key(I) %> = <%= comMap(I) %></OPTION>
                        <% End If %>
                    <% Next %>
                </SELECT><BR>
                <INPUT TYPE="SUBMIT" NAME="Edit" VALUE="Edit">
                <INPUT TYPE="SUBMIT" NAME="Remove" VALUE="Remove">
                <INPUT TYPE="SUBMIT" NAME="RemoveAll" VALUE="Remove All"><BR>
                <SELECT NAME="AliasPreset" CLASS="inpsel">
                    <%
                        For I = 1 to aliaspresets.Count
                            %><OPTION VALUE="<%= aliaspresets.Key(I) %>"><%= aliaspresets(I)("description") %></OPTION><%
                        Next
                    %>
                </SELECT>
                <INPUT TYPE="SUBMIT" NAME="AddPreset" VALUE="Add Pre-set">
                <HR>
                <DIV ALIGN="CENTER">
                    <TABLE>
                        <TR>
                            <TD>Alias (pseudo ProgID)
                            <A HREF="javascript: void window.open('help/default.asp?Page=commap.htm&Mark=Alias')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT CLASS="inp" TYPE="TEXT" NAME="aliasName" VALUE="<%= aliasName %>" SIZE="30">
                            <INPUT TYPE="BUTTON" VALUE="Paste" onClick="pasteProgID()"></TD>
                        </TR>
                        <TR>
                            <TD>COM Class ID
                            <A HREF="javascript: void window.open('help/default.asp?Page=commap.htm&Mark=ClsID')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT CLASS="inp" TYPE="TEXT" NAME="aliasCLSID" VALUE="<%= aliasCLSID %>" SIZE="30">
                            <INPUT TYPE="BUTTON" VALUE="Paste" onClick="pasteCLSID()"></TD>
                        </TR>
                    </TABLE>
                    <INPUT TYPE="SUBMIT" NAME="Update" VALUE="Add/Update">
                </DIV>
            </FORM>
            </DIV>
        <% End If %>
    </td>
  </tr>
</table>

</body>

</html>
